// Developed by Fabrice Bline
// Cemagref
// Aout 2004
function [x,y,typ]=IAPreacteur_ASM1(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)

case 'set' then,

  x=arg1;
  graphics=arg1.graphics;
  exprs=graphics.exprs;
  model=arg1.model;

  exprs1=[exprs(1);exprs(2);exprs(3);exprs(4);exprs(5)];
  exprs2=[exprs(6); exprs(7); exprs(8); exprs(9); exprs(10); exprs(11); exprs(12); exprs(13); exprs(14); exprs(15); exprs(16); exprs(17); exprs(18); exprs(19)];
  exprs3=[exprs(20); exprs(21); exprs(22)];
  exprs4=[exprs(23);exprs(24);exprs(25);exprs(26);exprs(27);exprs(28);exprs(29);exprs(30);exprs(31);exprs(32);exprs(33);exprs(34);exprs(35);exprs(38);exprs(39)];
  exprs5=[exprs(36)];
  exprs6=[exprs(37)];


  n=1;
 
  n=x_choose(['Stoichiometric constants';'Kinetic constants';'Aeration capacity';'Initial states';'Temperature';'Withdrawal flow rate'],['Menu'])

  if n==1 then,
  while %t do
	[ok, Yh, Ya, fp, ixb, ixp, exprs1]=getvalue('Stochiometric constants - Model ASM1',..
	['Heterotrophic yield - Yh (gDCO/gDCO)';
	'Autotrophic yield - Ya (gDCO/gN)';
	'Inert fraction of biomass - fp (-)';
	'Nitrogen content of active biomass - ixb (gN/gDCO)';
	'Nitrogen content of inert biomass - ixp (gN/gDCO)'],..
	list('vec',1,..
	     'vec',1,..
	     'vec',1,..
	     'vec',1,..
	     'vec',1),..
	      exprs1)
  if ~ok then break , end
  if ok then,
	model.rpar(1)=Yh;
	model.rpar(2)=Ya;
	model.rpar(3)=fp;
	model.rpar(4)=ixb;
	model.rpar(5)=ixp;
	graphics.exprs(1)=exprs1(1);
	graphics.exprs(2)=exprs1(2);
	graphics.exprs(3)=exprs1(3);
	graphics.exprs(4)=exprs1(4);
	graphics.exprs(5)=exprs1(5);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end



  if n==2 then,
  while %t do
	[ok, muh, bh, Koh, Ks, Kno, ng, mua, ba, Koa, Knh, kh, Kx, nh, ka,exprs2]=getvalue('Kinetic constants - Model ASM1',..
	['Heterotrophic max. specific growth rate - muh (1/d)';
	'Heterotrophic decay rate - bh (1/d)';
	'Oxygen half-saturation coefficient for heterotrophs - Koh (gO2/m3)';
	'Ss half-saturation coefficient for heterotrophs - Ks (gDCO/m3)';
	'Sno half-saturation coefficient for heterotrophs - Kno (gN/m3)';
	'Anoxic growth factor reduction - ng (-)';
	'Autotrophic max. specific growth rate - mua (1/d)';
	'Autotrophic decay rate - ba (1/d)';
	'Oxygen half-saturation coefficient for Autotrophs - Koa (gO2/m3)';
	'Snh half-saturation coefficient for Autotrophs - Knh (gN/m3)';
	'Xs max. specific hydrolysis rate - kh (gDCO/(gDCO.d))';
	'Xs half-saturation coefficient - Kx (gDCO/gDCO)';
	'Anoxic hydrolysis factor reduction - nh (-)';
	'Ammonification rate - ka (m3.DCO/(g.d))'],..
	    list('vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	    exprs2)
  if ~ok then break , end
  if ok then,
	model.rpar(6)=muh;
	model.rpar(7)=bh;
	model.rpar(8)=Koh;
	model.rpar(9)=Ks;
	model.rpar(10)=Kno;
	model.rpar(11)=ng;
	model.rpar(12)=mua;
	model.rpar(13)=ba;
	model.rpar(14)=Koa;
	model.rpar(15)=Knh;
	model.rpar(16)=kh;
	model.rpar(17)=Kx;
	model.rpar(18)=nh;
	model.rpar(19)=ka;
	graphics.exprs(6)=exprs2(1);
	graphics.exprs(7)=exprs2(2);
	graphics.exprs(8)=exprs2(3);
	graphics.exprs(9)=exprs2(4);
	graphics.exprs(10)=exprs2(5);
	graphics.exprs(11)=exprs2(6);
	graphics.exprs(12)=exprs2(7);
	graphics.exprs(13)=exprs2(8);
	graphics.exprs(14)=exprs2(9);
	graphics.exprs(15)=exprs2(10);
	graphics.exprs(16)=exprs2(11);
	graphics.exprs(17)=exprs2(12);
	graphics.exprs(18)=exprs2(13);
	graphics.exprs(19)=exprs2(14);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end


  if n==3 then,

  while %t do

 		 [ok, Kla, Alpha, Beta, exprs3]=getvalue(' Aeration capacity',..
			['Mass transfer coefficient - Kla (1/d)';
			'Alpha factor(-)';
			'Beta factor (-)'],..
	 		   list('vec',1,..
			    'vec',1,..
			    'vec',1),..
			      exprs3)

  if ~ok then break , end

  if ok then,
	model.rpar(20)=Kla;
	model.rpar(21)=Alpha;
	model.rpar(22)=Beta;
	graphics.exprs(20)=exprs3(1);
	graphics.exprs(21)=exprs3(2);
	graphics.exprs(22)=exprs3(3);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end



  if n==4 then,

  while %t do
   [ok, Si, Ss, Xi, Xs, Xbh, Xba, Xp, So, Sno, Snh, Snd, Xnd, Volume, FILE_OUT, FILE_IN, exprs4]=getvalue('Initial States',..
	['Soluble inert COD - Si (gDCO/m3)';
	'Readily biodegradable COD - Ss (gDCO/m3)';
	'Particulate inert COD - Xi (gDCO/m3)';
	'Slowly Biodegradable COD - Xs (gDCO/m3)';
	'Active heterotrophic biomass - Xbh (gDCO/m3)';
	'Active autotrophic biomass - Xba (gDCO/m3)';
	'Particulate inert COD from biomass - Xp (gDCO/m3)';
	'Dissolved oxygen - So (gO2/m3)';
	'Nitrate+nitrite - Sno (gN/m3)';
	'Ammonium+ammonia - Snh (gN/m3)';
	'Soluble organic nitrogen - Snd (gN/m3)';
	'Particulate organic nitrogen - Xnd (gN/m3)';
	'Volume (m3)';
	'Save final states (0/1)';
	'Load initial states (0/1)'],..
	    list('vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	    exprs4)
  
  if ~ok then break , end

  if ok then,
   	x0=[Si; Ss; Xi; Xs; Xbh; Xba; Xp; So; Sno; Snh; Snd; Xnd; Volume];
   	model.state=x0(:);
	model.rpar(25)=FILE_OUT;
	model.rpar(26)=FILE_IN;
	graphics.exprs(23)=exprs4(1);
	graphics.exprs(24)=exprs4(2);
	graphics.exprs(25)=exprs4(3);
	graphics.exprs(26)=exprs4(4);
	graphics.exprs(27)=exprs4(5);
	graphics.exprs(28)=exprs4(6);
	graphics.exprs(29)=exprs4(7);
	graphics.exprs(30)=exprs4(8);
	graphics.exprs(31)=exprs4(9);
	graphics.exprs(32)=exprs4(10);
	graphics.exprs(33)=exprs4(11);
	graphics.exprs(34)=exprs4(12);
	graphics.exprs(35)=exprs4(13);
	graphics.exprs(38)=exprs4(14);
	graphics.exprs(39)=exprs4(15);
  	x.graphics=graphics;
  	x.model=model;

   break;
  end
  end
  end

  if n==5 then,

  while %t do

		[ok,Temperature,exprs5]=getvalue('Temperature',..
       		     ['Temperature (Deg. Celcius)'],..
		    list('vec',1),..
		    exprs5)

  if ~ok then break , end

 if ok then,
	model.rpar(23)=Temperature;
	graphics.exprs(36)=exprs5(1);
	x.graphics=graphics;
	x.model=model;	
	break;
 end
 end
 end



 if n==6 then,

 while %t do

	[ok,Qs,exprs6]=getvalue('Flow rate',..
	['Withdrawal flow rate (m3/h)'],..
	   list('vec',1),..
	   exprs6)

  if ~ok then break , end

  if ok then,
	model.rpar(24)=Qs;
	graphics.exprs(37)=exprs6(1);
	x.graphics=graphics;
	x.model=model;	
	break;
  end
  end
  end


 case 'define' then
  Yh=0.67;
  Ya=0.24;
  fp=0.08;
  ixb=0.086;
  ixp=0.06;

  muh=6.0;
  bh=0.62;
  Koh=0.2;
  Ks=20;
  Kno=0.5;
  ng=0.8;
  mua=0.8;
  ba=0.04;
  Koa=0.4;
  Knh=1.0;
  kh=3;
  Kx=0.03;
  nh=0.4;
  ka=0.08;

  Kla=3000;
  Alpha=0.8;
  Beta=0.95;

  Si=30;
  Ss=10;
  Xi=10;
  Xs=15;
  Xbh=500;
  Xba=50;
  Xp=10;
  So=1;
  Sno=10;
  Snh=10;
  Snd=10;
  Xnd=10;
  Volume=200;

  Temperature=20;

  Qs=20;
  
  FILE_OUT=0;
  FILE_IN=0;

  x0=[Si; Ss; Xi; Xs; Xbh; Xba; Xp; So; Sno; Snh; Snd; Xnd; Volume]
  rpar=[Yh; Ya; fp; ixb; ixp; muh; bh; Koh; Ks; Kno; ng; mua; ba; Koa; Knh; kh; Kx; nh; ka; Kla; Alpha; Beta; Temperature; Qs; FILE_OUT; FILE_IN];
  in=[13;3];out=[13;1]

  model=scicos_model()
  model.sim=list('IAPreacteur_ASM1',1)
  model.in=in
  model.out=out
  model.evtin=[]
  model.state=x0(:)
  model.rpar=rpar;
  model.blocktype='c'
  model.dep_ut=[%f %t]

  exprs=[string(Yh);
	string(Ya);
	string(fp);
	string(ixb);
	string(ixp);
	string(muh);
	string(bh);
	string(Koh);
	string(Ks);
	string(Kno);
	string(ng);
	string(mua);
	string(ba);
	string(Koa);
	string(Knh);
	string(kh);
	string(Kx);
	string(nh);
	string(ka);
	string(Kla);
	string(Alpha);
	string(Beta);
	string(Si);
	string(Ss);
	string(Xi);
	string(Xs);
	string(Xbh);
	string(Xba);
	string(Xp);
	string(So);
	string(Sno);
	string(Snh);
	string(Snd);
	string(Xnd);
	string(Volume);
	string(Temperature);
	string(Qs);
        string(FILE_OUT);
        string(FILE_IN)]

  gr_i=list(['thick=xget(''thickness'');';
	'pat=xget(''pattern'');';
	'fnt=xget(''font'');';
	'xset(''font'',fnt(1),2);';
 	'xset(''pattern'',scs_color(1));';
	'xstringb(orig(1)+0.17*sz(1),orig(2)+0.32*sz(2),''Cycle [3]'',0,0);';
	'xstringb(orig(1)+0.22*sz(1),orig(2)+0.66*sz(2),''Influent [13]'',0,0);';
	'xstringb(orig(1)+0.8*sz(1),orig(2)+0.32*sz(2),''Volume [1]'',0,0);';
	'xstringb(orig(1)+0.78*sz(1),orig(2)+0.66*sz(2),''Effluent [13]'',0,0);';
 	'xset(''pattern'',scs_color(2));';
	'xset(''font'',fnt(1),4);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.85*sz(2),''IAP Reactor'',0,0);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.15*sz(2),''ASM1'',0,0);';
	'xset(''font'',fnt(1),1);';
	'xset(''pattern'',pat);'],4)

  x=standard_define([6 8],model,exprs,gr_i);
end
endfunction
