/* Developed by Fabrice Bline */
/* Cemagref */
/* Aout 2004 */

#include "stdio.h"
#include "stdlib.h"
#include "math.h"

#define  Si x[0]
#define  Ss x[1]
#define  Xi x[2]
#define  Xs x[3]
#define  Xbh x[4]
#define  Xba x[5]
#define  Xp x[6]
#define  So x[7]
#define  Sno x[8]
#define  Snh x[9]
#define  Snd x[10]
#define  Xnd x[11]
#define  Vr x[12]

#define Yh rpar[0]
#define Ya rpar[1]
#define fp rpar[2]
#define ixb rpar[3]
#define ixp rpar[4]

#define muh rpar[5]
#define bh rpar[6]
#define Koh rpar[7]
#define Ks rpar[8]
#define Kno rpar[9]
#define ng rpar[10]
#define mua rpar[11]
#define ba rpar[12]
#define Koa rpar[13]
#define Knh rpar[14]
#define kh rpar[15]
#define Kx rpar[16]
#define nh rpar[17]
#define ka rpar[18]

#define Alpha rpar[20]
#define Beta rpar[21]

#define Temperature rpar[22]

#define FILE_OUT rpar[24]
#define FILE_IN rpar[25]

#define Qa u1[0]
#define Sia u1[1]
#define Ssa u1[2]
#define Xia u1[3]
#define Xsa u1[4]
#define Xbha u1[5]
#define Xbaa u1[6]
#define Xpa u1[7]
#define Soa u1[8]
#define Snoa u1[9]
#define Snha u1[10]
#define Snda u1[11]
#define Xnda u1[12]

#define Feeding u2[0]
#define Aeration u2[1]
#define Withdraw u2[2]

#define Cs Beta*(-0.0000661858*pow(Temperature,3)+0.0075161751*pow(Temperature,2)-0.3999077443*Temperature+14.58958)

#define process1 muh*(Ss/(Ks+Ss))*(So/(Koh+So))*Xbh
#define process2 ng*muh*(Ss/(Ks+Ss))*(Koh/(Koh+So))*(Sno/(Kno+Sno))*Xbh
#define process3 mua*(Snh/(Knh+Snh))*(So/(Koa+So))*Xba
#define process4 bh*Xbh
#define process5 ba*Xba
#define process6 ka*Snd*Xbh
#define process7 kh*((Xs/Xbh)/(Kx+(Xs/Xbh)))*((So/(Koh+So))+nh*(Koh/(Koh+So))*(Sno/(Kno+Sno)))*Xbh
#define process8 process7*(Xnd/Xs)

void IAPreacteur_ASM1(int * flag, int *nevprt, double* t, double* xd, double* x,
	     int* nx, double* z, int *nz, double* tvec, int* ntvec,
	     double* rpar, int* nrpar, int* ipar, int* nipar, double* u1,
	     int* nu1,double* u2, int* nu2, double* y1, int* ny1, double* y2,
	     int* ny2)

{
  float Qs;
  float Kla;
  float temp1,temp2,temp3,temp4,temp5,temp6,temp7,temp8,temp9,temp10,temp11,temp12,temp13;
  FILE *stream;
  char file[]="state.asm1";

  if (Withdraw==1) 
    { 
      Qs=rpar[23]*24;  
    } 
  else 
    { 
      Qs=0;
    }


  if (Aeration==1)
    {
      Kla=Alpha*rpar[19]; 
    }
  else 
    {  
      Kla=0;
    } 


 if (*flag==4 && FILE_IN==1)
    {
      /*  Initialisation */
      if ((stream=fopen(file, "r"))==NULL)
	{
	  /*printf("Ouverture du fichier impossible");*/
	  exit(-1); 
	}
      else
	{
	  fscanf(stream, "%f%f%f%f%f%f%f%f%f%f%f%f%f",&temp1,&temp2,&temp3,&temp4,&temp5,&temp6,&temp7,&temp8,&temp9,&temp10,&temp11,&temp12,&temp13);
	  fclose(stream);
	  Si=temp1;
	  Ss=temp2;
	  Xi=temp3;
	  Xs=temp4;
	  Xbh=temp5;
	  Xba=temp6;
	  Xp=temp7;
	  So=temp8;
	  Sno=temp9;
	  Snh=temp10;
	  Snd=temp11;
	  Xnd=temp12;
	  Vr=temp13;
	}
    }
 else
   {
     if (*flag==5 && FILE_OUT==1)
       {
	 /*  Ending */
	 if ((stream=fopen(file, "w"))==NULL)
	   {
	     exit(-1);
	   }
	 else
	   {
	     fprintf(stream,"%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\t%.1f\n",y1[1],y1[2],y1[3],y1[4],y1[5],y1[6],y1[7],y1[8],y1[9],y1[10],y1[11],y1[12],y2[0]);
	     fclose(stream);
	   }

       }
     else
       {
	 if (*flag==1||*flag==6)
	   {
	     y1[0]=Qs;
	     y1[1]=Si;
	     y1[2]=Ss;
	     y1[3]=Xi;
	     y1[4]=Xs;
	     y1[5]=Xbh;
	     y1[6]=Xba;
	     y1[7]=Xp;
	     y1[8]=So;
	     y1[9]=Sno;
	     y1[10]=Snh;
	     y1[11]=Snd;
	     y1[12]=Xnd;
	     y2[0]=Vr;
	   }
	 else
	   {
	     if (*flag==0)
	       {
		 xd[0]=Qa*(Sia-Si)/Vr;
		 xd[1]=Qa*(Ssa-Ss)/Vr-1/Yh*process1-1/Yh*process2+process7;
		 xd[2]=Qa*(Xia-Xi)/Vr;
		 xd[3]=Qa*(Xsa-Xs)/Vr+(1-fp)*process4 +(1-fp)*process5 -process7;
		 xd[4]=Qa*(Xbha-Xbh)/Vr+process1 +process2 -process4;
		 xd[5]=Qa*(Xbaa-Xba)/Vr+process3 -process5;
		 xd[6]=Qa*(Xpa-Xp)/Vr+fp*process4 +fp*process5;
		 xd[7]=Qa*(Soa-So)/Vr-((1-Yh)/Yh)*process1 -((4.57-Ya)/Ya)*process3 + Kla*(Cs-So);
		 xd[8]=Qa*(Snoa-Sno)/Vr-((1-Yh)/(2.86*Yh))*process2+1/Ya*process3;
		 xd[9]=Qa*(Snha-Snh)/Vr-ixb*process1 -ixb*process2 -(ixb+1/Ya)*process3 +process6;
		 xd[10]=Qa*(Snda-Snd)/Vr-process6 +process8;
		 xd[11]=Qa*(Xnda-Xnd)/Vr+(ixb-fp*ixp)*process4 +(ixb-fp*ixp)*process5 -process8;
		 xd[12]=Qa-Qs;
	       }
	   }
       }
   }
 
 return;
}

